=== debian/changelog ===
telegraf (1.21.2+ds1-0ubuntu1) jammy; urgency=medium

  * New upstream version 1.21.2+ds1 (LP: #1957596)
  * d/control: Bump Standards-Version to 4.6.0.1.
  * d/copyright: Update.
  * d/s/lintian-overrides: New override to silence a false-positive.
    Lintian is flagging that one of the vendorized modules uses a non-free
    license (JSON license).  This is actually not accurate; the license is
    mentioned in the LICENSE.txt file, but not used in any of the source
    files distributed with the module.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Wed, 12 Jan 2022 18:25:20 -0500
