=== debian/changelog ===
telegraf (1.21.4+ds1-0ubuntu2+esm2) jammy-security; urgency=medium

  * SECURITY UPDATE: Possible buffer overflow
    - debian/patches/CVE-2022-29189.patch:
      vendor/github.com/pion/dtls/v2/errors.go and
      vendor/github.com/pion/dtls/v2/fragment_buffer.go were modified
      to impose limit on the amount of data that is buffered during the
      handshake.
    - CVE-2022-29189
  * SECURITY UPDATE: Possible denial of Service
    - debian/patches/CVE-2022-29190.patch:
      vendor/github.com/pion/dtls/v2/fragment_buffer.go was modified to
      prevent the fragmentBuffer from processing zero length fragments.
    - CVE-2022-29190
  * SECURITY UPDATE: Improper Certificate Validation
    - debian/patches/CVE-2022-29222.patch:
      vendor/github.com/pion/dtls/v2/flight4handler.go was modified to
      require CertificateVerify when Client Cert is sent.
    - CVE-2022-29222
  * debian/control: Updated dependency golang-go to golang-1.17-go
  * debian/rules: Added go path

 -- Chrisa Oikonomou <chrisa.oikonomou@canonical.com>  Thu, 15 Jan 2026 16:47:34 +0200

telegraf (1.21.4+ds1-0ubuntu2) jammy; urgency=medium

  * Temporarily allow SHA1 certs in test cases only to fix tests with Go 1.18
  * Fix redundant newlines in test data passed to fmt.Fprintln

 -- William 'jawn-smith' Wilson <jawn-smith@ubuntu.com>  Thu, 17 Mar 2022 11:28:18 -0500

telegraf (1.21.4+ds1-0ubuntu1) jammy; urgency=medium

  * New upstream version 1.21.4+ds1 (LP: #1957596)
  * d/copyright: Remove unused line referring to the StackExchange
    module, which has been dropped by upstream.
  * d/rules: Reenable inputs/riemann_listener test.
  * d/rules: Reenable telegraf/agent test on armhf.

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Wed, 16 Feb 2022 21:51:27 -0500
